<template>
    <div class="pl-4 pr-4 pt-4">
        <h1>{{ isCreateArticle ? `New Article` : `Edit Article` }}</h1>
        <BContainer class="ml-0 mr-0 mt-4 full-width" fluid>
            <BFormRow>
                <BCol xl="9" lg="9" md="9">
                    <BForm>
                        <!--Title-->
                        <BaseValidationInput
                            input-label="Title"
                            :input-value="form.title"
                            input-name="articleTitle"
                            inputType="text"
                            @update="form.title = $event"
                        />
                        <!--Description-->
                        <BaseValidationInput
                            input-label="Description"
                            :input-value="form.description"
                            input-name="articleDescription"
                            inputType="text"
                            @update="form.description = $event"
                        />
                        <!--Body-->
                        <BaseValidationTextArea
                            input-label="Body"
                            :input-value="form.body"
                            input-name="articleBody"
                            inputType="text"
                            inputNumberOfRows="6"
                            @update="form.body = $event"
                        />
                    </BForm>
                </BCol>
                <BCol xl="3" lg="3" md="3" class="pl-0 pl-md-4">
                    <BFormGroup id="article-tag" label="Tag" label-for="article-tag">
                        <BFormInput id="article-tag" v-model="newTag" placeholder="New tag" type="text" v-on:keyup="handleAddNewTag"></BFormInput>
                    </BFormGroup>
                    <BFormGroup label="" v-slot="{ ariaDescribedby }" class="border border-light rounded p-3 border-color fix-height">
                        <BFormCheckboxGroup
                            id="article-tag-list"
                            v-model="form.tagList"
                            :options="tagItems"
                            :aria-describedby="ariaDescribedby"
                            name="flavour-1"
                            stacked
                        ></BFormCheckboxGroup>
                    </BFormGroup>
                </BCol>
            </BFormRow>
            <BButton variant="primary" class="pr-4 pl-4" @click.prevent="createAnArticle()">
                <BSpinner variant="light" v-show="isLoading"></BSpinner>
                <span class="whiteText" v-show="!isLoading">Submit</span>
            </BButton>
        </BContainer>
    </div>
</template>

<script>
import BaseValidationTextArea from '@/components/Base/BaseValidationTextarea';
import BaseValidationInput from '@/components/Base/BaseValidationInput';
export default {
    name: 'CreateArticle',
    components: { BaseValidationTextArea, BaseValidationInput },
    data() {
        return {
            isCreateArticle: true,
            form: {
                title: '',
                description: '',
                body: '',
                tagList: [],
            },
            newTag: '',
            tagItems: [],
            isLoading: false,
        };
    },
    async created() {
        /*Get all tags*/
        const response = await this.$root.axiosApiCall('Get Tags Failed', 'get', 'tags', {}, {});
        this.tagItems = response.tags;
        /*Is it New article or Edit Article*/
        if (this.$route.name === 'EditArticle') {
            this.isCreateArticle = false;
            /*Get article data from api*/
            const articleResponse = await this.$root.axiosApiCall('title', 'get', `articles/${this.$route.params.slug}`, {}, {});
            /*Fill form with article data*/
            this.form = articleResponse.article;
            /*if tags doesnt have that tag add it */
            const tagsDifference = this.form.tagList.filter((x) => this.tagItems.indexOf(x) === -1);
            if (tagsDifference && tagsDifference.length) {
                console.log('tagsDifference', tagsDifference);
                this.tagItems.push(...tagsDifference);
            }
        }
    },
    methods: {
        validateState(ref) {
            if (this.veeFields[ref] && (this.veeFields[ref].dirty || this.veeFields[ref].validated)) {
                return !this.veeErrors.has(ref);
            }
            return null;
        },
        handleAddNewTag(event) {
            if (event.keyCode === 13) {
                this.tagItems.unshift(this.newTag);
                this.form.tagList.push(this.newTag);
            }
        },
        createAnArticle() {
            this.$validator.validateAll().then(async (isOkeyValidation) => {
                if (!isOkeyValidation) {
                    return;
                }
                this.isLoading = true;
                console.log('success validation');
                if (this.isCreateArticle) {
                    const response = await this.$root.axiosApiCall('Article Failed', 'post', 'articles', {}, { article: this.form });
                    if (response && response.status == '200') {
                        /* Show success notification */
                        this.$root.makeToastNotification('success', 'Well done! ', ' Article created successfully');
                        /* Redirect to article */
                        this.$router.push('/article');
                    }
                } else {
                    const response = await this.$root.axiosApiCall(
                        'Article Failed',
                        'put',
                        `articles/${this.$route.params.slug}`,
                        {},
                        { article: this.form },
                    );
                    if (response && response.status == '200') {
                        /* Show success notification */
                        this.$root.makeToastNotification('success', 'Well done! ', ' Article Updated successfully');
                        /* Redirect to article */
                        this.$router.push('/article');
                    }
                }
                this.isLoading = false;
            });
        },
    },
};
</script>

<style scoped>
.border-color {
    border-color: #dddddd !important;
}
.fix-height {
    height: 280px;
    overflow-y: scroll;
}
</style>
